#!/bin/sh
## migafp.sh
#
# Copyright © [2006(S)] Novell, Inc.  All Rights Reserved.
#
# USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE DEVELOPER LICENSE
# AGREEMENT OR OTHER AGREEMENT THROUGH WHICH NOVELL, INC. MAKES THE WORK
# AVAILABLE. THIS WORK MAY NOT BE ADAPTED WITHOUT  NOVELL'S PRIOR WRITTEN
# CONSENT.
#
# NOVELL PROVIDES THE WORK "AS IS," WITHOUT ANY EXPRESS OR IMPLIED WARRANTY,
# INCLUDING WITHOUT THE IMPLIED WARRANTIES OF MERCHANTABILITY,FITNESS FOR
# A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  NOVELL, THE AUTHORS OF THE
# WORK, AND THE OWNERS OF COPYRIGHT IN THE WORK ARE NOT LIABLE FOR ANY
# CLAIM, DAMAGES, OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT, OR OTHERWISE, ARISING FROM, OUT OF, OR IN CONNECTION WITH THE WORK
# OR THE USE OR OTHER DEALINGS IN THE WORK.
#
# All rights reserved.
#
# Author: Mary Joseph feedback to jmary@novell.com
# 

#This is the main migafpp script that performs the AFP server migration from NetWare to Linux based upon the inputs its receives.


Input()
{
#	echo "-h    | --help		 		Prints this summary"
#	echo "-s    | --source-server			IP address of the source server"
#	echo "-u    | --Source-admin			DN of the source tree admin"
#	echo "-w    | --Source-passwd			Password for the source tree admin"
#	echo "-b    | --Destination-admin	        DN of the destination tree admin"
#	echo "-x    | --Destination-passwd	        Password for the destination tree admin"
#echo "-m    | --type				Type of migration (different tree|same tree|server id swap|different tree different context|consolidation)"
#	echo "-q    | --Destination-ldap-port	        Port Number for the destination ldap server"
#	echo "-t    | --ssl		                1 for ssl bind 0 for non-ssl bind"
#	echo "-f    | --policy-file         	 	full path of file containing the Password Policy DNs, each separated by a new line"	 

	#echo "Usage: $1 -s SOURCE IP -u SOURCE ADMIN -b TARGET ADMIN[options]"
	echo "Usage: migafp [options]"
	echo "-h		 		Prints this summary"
	echo "-s				IP address of the source server"
	echo "-u    				DN of the tree admin (eg: cn=user.o=company)"
	echo "-w    				Password for the tree admin"
#	echo "-b    			        DN of the destination tree admin (eg: cn=user.o=company)"
#	echo "-x    			        Password for the destination tree admin"
#echo "-m    | --type				Type of migration (different tree|same tree|server id swap|different tree different context|consolidation)"
#	echo "-q    			        Port Number for the destination ldap server"
#	echo "-t    		                1 for ssl bind 0 for non-ssl bind"
#	echo "-f    	         	 	full path of file containing the Password Policy DNs, each separated by a new line"	 

	exit 1
}

if test $# -eq 0
then
Input
fi

PROXY_INFO_FILE="/opt/novell/afptcpd/bin/afpProxyuser.txt"
CONTEXT_FILE="/etc/opt/novell/afptcpd/afpdircxt.conf"
TEMP_CONTEXT_FILE="/etc/opt/novell/afptcpd/afpdircxt.conf.temp"
#while getopts m:s:u:p:q:b:x:t: o
#while getopts s:u:w:b:t:x:q:f:j:h o
while getopts s:u:w:h o
do      case "$o" in
        s)     SOURCE="$OPTARG";;
        u)     USERNAME="$OPTARG";;
        w)     PASSWORD="$OPTARG";;
#        b)     TARGETDN="$OPTARG";;
#        t)     SSLD="$OPTARG";;
#        x)     TARGETPASSWD="$OPTARG";;
#        q)     TARGETPORT="$OPTARG";;
#        f)     FILEPATH="$OPTARG";;
   #    m)     MODE="$OPTARG";;
#        j)     FRAMEWORK="$OPTARG";;
        h)     Input;;
       [?])    Input;
                exit 1;;
        esac
done
shift


#error checking for the inputs

#if [ "$MODE" == "" ]; then

#Input
  #if mode is "" or 5 we can assume it to be same tree

   #if [ "$SOURCE" == "" ]; then
	#shud try to take the ip of the machine on which script is running
   #fi
#fi

if [ "$SOURCE" == "" ]; then
	Input
fi
: '
if [ "$SSLD" == "" ]; then
	Input
fi

if [ "$TARGETPORT" == "" ]; then
 	Input
fi
'
if [ "$USERNAME" == "" ]; then
	Input
fi
: '
if [ "$TARGETDN" == "" ]; then
	Input
fi
'
if [ "$PASSWORD" == "" ]; then
	if [ "$FRAMEWORK" == "" ]; then
		echo "Enter source tree admin user password:"
	fi
	mode=`stty -g`
	stty -echo
	read PASSWORD
	stty $mode
fi
: '
if [ "$TARGETPASSWD" == "" ]; then
	if [ "$FRAMEWORK" == "" ]; then
        	echo "Enter target tree admin user password:"
	fi
        mode=`stty -g`
        stty -echo
        read TARGETPASSWD
        stty $mode
fi

TARGETDN=`echo $TARGETDN | tr . ,`
'
export PASSWORD
#export TARGETPASSWD

var1=`perl /opt/novell/migration/sbin/migafp.pl -s "$SOURCE" -u "$USERNAME"`

if [ "$?" -gt "0" ];then
	echo var >> /var/log/migafp.log
	echo "An Error occurred while migrating the contexts.Please check /var/log/migafp.log" >> /var/log/migafp.log
	exit 1
fi
#Netware context file may contain guest user FDN also. But OES AFP afpdircxt.conf file only allows contexts.No user FDN.
#So, after migration remove any entry that starts with "cn" from afpdircxt.conf file
awk 'match($0,"cn=") == 0 {print $0}' $CONTEXT_FILE > $TEMP_CONTEXT_FILE
mv $TEMP_CONTEXT_FILE $CONTEXT_FILE
/opt/novell/afptcpd/bin/afp_retrieve_proxy_cred.sh username $PROXY_INFO_FILE >> /dev/null 2>&1
if [ $? != 0 ];then
	echo "Error in retrieving the proxy user credentials." >> /var/log/migafp.log
	exit 1
fi
if [ -f $PROXY_INFO_FILE ];
then
	read AFP_PRXY < $PROXY_INFO_FILE
	rm -f $PROXY_INFO_FILE
fi
SRVR_IP=`/opt/novell/eDirectory/bin/ndsconfig get n4u.server.interfaces | grep -v ^$ | grep n4u | sed s/[a-zA-Z0-9.]*=//g| sed s/@[a-zA-Z0-9]*//g`
USERNAME=`echo $USERNAME | sed 's/\.\([a-zA-Z]\+=\)/,\1/g'`
OES_DATA="$PASSWORD"
export OES_DATA
sh /opt/novell/afptcpd/bin/afp_proxy_rights_assign.sh -u "$AFP_PRXY" -d "$USERNAME" -i "$SRVR_IP" -p 636 -s 1 >> /var/log/migafp.log
rightsAssign=$?
if test $rightsAssign != 0
then
	echo "An Error occurred while migrating the contexts.Please check /var/log/migafp.log" >> /var/log/migafp.log
	exit $rightsAssign
else
        echo "Migration completed successfully. Please check /var/log/migafp.log for more details"
fi
: '
var2=`/opt/novell/migration/sbin/afpproxy`;
if [ $? != 0 ];then
	echo "Error in retrieving the proxy user credentials." >> /var/log/migafp.log
	exit 1
fi
 

var3=`perl /opt/novell/migration/sbin/migafpldif.pl  -b "$TARGETDN" -q $TARGETPORT -t $SSLD -g "$var2" -f "$FILEPATH"`
if [ "$?" -gt "0" ];then
	echo $var3 >> /var/log/migafp.log
	exit 1
fi
'
rm -f /tmp/afptemp.conf
#rm  /tmp/afpuserpwdpolicy.ldif
